org.jboss.jca.deployers.common

## Class AbstractResourceAdapterDeployer

- java.lang.Object
- - org.jboss.jca.deployers.common.AbstractResourceAdapterDeployer

-     public abstract class AbstractResourceAdapterDeployer
      extends java.lang.Object

  An abstract resource adapter deployer which contains common functionality for all resource adapter archive based deployers.
  Author:
    Jesper Pedersen

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected DeployersLogger` | `log` the logger
    `protected boolean` | `validateClasses` boolean to set if validation is needed at class level or it should be considered already valid (IOW object put in repository at previous steps have been already validated at class level

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractResourceAdapterDeployer(boolean validateClasses)` Create a new AbstractResourceAdapterDeployer.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `applyCapacity(org.jboss.jca.common.api.metadata.resourceadapter.ConnectionDefinition connectionDefinition, org.jboss.jca.core.connectionmanager.pool.api.Pool pool, boolean isCRI)` Apply capacity
    `protected void` | `associateResourceAdapter(javax.resource.spi.ResourceAdapter resourceAdapter, java.lang.Object object)` Associate resource adapter with ojects if they implement ResourceAdapterAssociation
    `protected abstract java.lang.String[]` | `bindAdminObject(java.net.URL url, java.lang.String deploymentName, java.lang.Object ao)` Bind admin object into JNDI
    `protected abstract java.lang.String[]` | `bindAdminObject(java.net.URL url, java.lang.String deploymentName, java.lang.Object ao, java.lang.String jndiName)` Bind admin object into JNDI
    `protected abstract java.lang.String[]` | `bindConnectionFactory(java.net.URL url, java.lang.String deploymentName, java.lang.Object cf)` Bind connection factory into JNDI
    `protected abstract java.lang.String[]` | `bindConnectionFactory(java.net.URL url, java.lang.String deploymentName, java.lang.Object cf, java.lang.String jndiName)` Bind connection factory into JNDI
    `protected java.lang.String` | `buildJndiName(java.lang.String jndiName, java.lang.Boolean javaContext)` Build the jndi name
    `protected abstract boolean` | `checkActivation(org.jboss.jca.common.api.metadata.spec.Connector cmd, org.jboss.jca.common.api.metadata.resourceadapter.Activation activation)` Check if the resource adapter should be activated based on the ironjacamar.xml input
    `protected abstract boolean` | `checkConfigurationIsValid()` check if the configuration for this deployer has been set to a valid value
    `protected org.jboss.jca.core.spi.security.Callback` | `createCallback(org.jboss.jca.common.api.metadata.resourceadapter.WorkManagerSecurity ws)` Get a callback implementation
    `protected CommonDeployment` | `createObjectsAndInjectValue(java.net.URL url, java.lang.String deploymentName, java.io.File root, java.lang.ClassLoader cl, org.jboss.jca.common.api.metadata.spec.Connector cmd, org.jboss.jca.common.api.metadata.resourceadapter.Activation activation)` create objects and inject value for this deployment. it is a general method returning a `CommonDeployment` to be used to exchange objects needed to real injection in the container
    `protected org.jboss.jca.core.api.connectionmanager.pool.PoolConfiguration` | `createPoolConfiguration(org.jboss.jca.common.api.metadata.common.Pool pp, org.jboss.jca.common.api.metadata.common.TimeOut tp, org.jboss.jca.common.api.metadata.common.Validation vp)` Create an instance of the pool configuration based on the input
    `protected javax.security.auth.Subject` | `createSubject(org.jboss.jca.core.spi.security.SubjectFactory subjectFactory, java.lang.String securityDomain, javax.resource.spi.ManagedConnectionFactory mcf)` Create a subject
    `protected java.util.Set<org.jboss.jca.common.api.metadata.resourceadapter.AdminObject>` | `findAdminObjects(java.lang.String clz, java.util.Set<java.lang.String> aos, java.util.List<org.jboss.jca.common.api.metadata.resourceadapter.AdminObject> defs)` Find the metadata for an admin object
    `protected java.util.Set<org.jboss.jca.common.api.metadata.resourceadapter.ConnectionDefinition>` | `findConnectionDefinitions(java.lang.String clz, java.util.Set<java.lang.String> mcfs, java.util.List<org.jboss.jca.common.api.metadata.resourceadapter.ConnectionDefinition> defs, java.lang.ClassLoader cl)` Find the metadata for a managed connection factory
    `protected BeanValidation` | `getBeanValidation()` Get the bean validation module
    `protected abstract org.jboss.jca.core.api.connectionmanager.ccm.CachedConnectionManager` | `getCachedConnectionManager()` Get the cached connection manager
    `Configuration` | `getConfiguration()` Get the configuration
    `protected abstract DeployersLogger` | `getLogger()` Get the logger
    `protected abstract java.io.PrintWriter` | `getLogPrintWriter()` get a PrintWriter where logger will put its output
    `protected abstract java.io.File` | `getReportDirectory()` get The directory where write error reports
    `protected abstract org.jboss.jca.core.spi.security.SubjectFactory` | `getSubjectFactory(org.jboss.jca.common.api.metadata.common.SecurityMetadata securityMetadata, java.lang.String jndiName)` Get a subject factory
    `protected abstract org.jboss.jca.core.spi.transaction.TransactionIntegration` | `getTransactionIntegration()` Get the transaction integration.
    `protected abstract javax.transaction.TransactionManager` | `getTransactionManager()` Get the transaction Manager.
    `protected boolean` | `hasFailuresLevel(java.util.Collection<org.jboss.jca.validator.Failure> failures, int severity)` Cehck for failures at a certain level
    `protected java.util.Set<org.jboss.jca.validator.Failure>` | `initActivationSpec(java.lang.ClassLoader cl, org.jboss.jca.common.api.metadata.spec.Connector cmd, javax.resource.spi.ResourceAdapter resourceAdapter, java.util.List<org.jboss.jca.validator.Validate> archiveValidationObjects, java.util.List<java.lang.Object> beanValidationObjects, java.util.Set<org.jboss.jca.validator.Failure> failures, java.net.URL url, boolean activateDeployment)` init the acrtivation spec
    `protected java.util.Set<org.jboss.jca.validator.Failure>` | `initAdminObject(org.jboss.jca.common.api.metadata.spec.Connector cmd, java.lang.ClassLoader cl, java.util.List<org.jboss.jca.validator.Validate> archiveValidationObjects, java.util.List<java.lang.Object> beanValidationObjects, java.util.Set<org.jboss.jca.validator.Failure> failures, java.net.URL url, java.lang.String deploymentName, boolean activateDeployment, javax.resource.spi.ResourceAdapter resourceAdapter, java.util.List<org.jboss.jca.common.api.metadata.resourceadapter.AdminObject> aosAct, java.util.List<java.lang.Object> aos, java.util.List<java.lang.String> aoJndiNames, org.jboss.jca.core.api.management.Connector mgtConnector)` init an Admin Object
    `protected abstract java.lang.Object` | `initAndInject(java.lang.String value, java.util.List<? extends org.jboss.jca.common.api.metadata.spec.ConfigProperty> cpm, java.lang.ClassLoader cl)` Initialize and inject configuration properties into container
    `java.lang.String` | `printFailuresLog(java.lang.String urlFileName, org.jboss.jca.validator.Validator validator, java.util.Collection<org.jboss.jca.validator.Failure> failures, java.io.File reportDirectory, org.jboss.jca.validator.FailureHelper... fhInput)` print Failures into Log files.
    `protected abstract void` | `registerResourceAdapterToMDR(java.net.URL url, java.io.File root, org.jboss.jca.common.api.metadata.spec.Connector cmd, org.jboss.jca.common.api.metadata.resourceadapter.Activation activation)` Register the ResourceAdapter to the MDR.
    `protected abstract java.lang.String` | `registerResourceAdapterToResourceAdapterRepository(javax.resource.spi.ResourceAdapter instance)` Register the ResourceAdapter to the ResourceAdapterRepository.
    `protected boolean` | `requireExplicitJndiBindings()` Require explicit JNDI bindings
    `protected boolean` | `scanArchive(org.jboss.jca.common.api.metadata.spec.Connector cmd)` Should the archive be scanned for annotations
    `protected void` | `setCallbackSecurity(org.jboss.jca.core.api.workmanager.WorkManager workManager, org.jboss.jca.core.spi.security.Callback cb)` Sets the call back security info in this rar work manager before starting the resource adapter.
    `void` | `setConfiguration(Configuration value)` Set the configuration
    `protected abstract void` | `setRecoveryForResourceAdapterInResourceAdapterRepository(java.lang.String key, boolean isXA)` Set recovery mode for a resource adapter in the ResourceAdapterRepository
    `void` | `start()` Start
    `protected void` | `startContext(javax.resource.spi.ResourceAdapter resourceAdapter, java.lang.String bootstrapContextIdentifier, java.lang.String bootstrapContextName, org.jboss.jca.core.spi.security.Callback cb)` Start the resource adapter
    `java.util.Set<org.jboss.jca.validator.Failure>` | `validateArchive(java.net.URL url, java.util.List<org.jboss.jca.validator.Validate> archiveValidation, java.util.Set<org.jboss.jca.validator.Failure> failures)` validate archive

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### log

          protected final DeployersLogger log

      the logger

    - #### validateClasses

          protected final boolean validateClasses

      boolean to set if validation is needed at class level or it should be considered already valid (IOW object put in repository at previous steps have been already validated at class level

  - ### Constructor Detail

    - #### AbstractResourceAdapterDeployer

          public AbstractResourceAdapterDeployer(boolean validateClasses)

      Create a new AbstractResourceAdapterDeployer.
      Parameters:
        `validateClasses` - validateClasses validateClasses boolean to express if this instance will apply validation on classes structure

  - ### Method Detail

    - #### setConfiguration

          public void setConfiguration(Configuration value)

      Set the configuration
      Parameters:
        `value` - value value The value

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the configuration
      Returns:
        The value

    - #### validateArchive

          public java.util.Set<org.jboss.jca.validator.Failure> validateArchive(java.net.URL url,
                                                                                java.util.List<org.jboss.jca.validator.Validate> archiveValidation,
                                                                                java.util.Set<org.jboss.jca.validator.Failure> failures)

      validate archive
      Parameters:
        `url` - url url of the archive
        `archiveValidation` - archiveValidation archiveValidation classes and/or to validate.
        `failures` - failures failures original list of failures
      Returns:
        The list of failures gotten with all new failures added. Null in case of no failures or if validation is not run according to `Configuration.getArchiveValidation()` Setting. It returns null also if the concrete implementation of this class set validateClasses instance variable to flase and the list of archiveValidation contains one or more instance of `ValidateClass` type

    - #### printFailuresLog

          public java.lang.String printFailuresLog(java.lang.String urlFileName,
                                                   org.jboss.jca.validator.Validator validator,
                                                   java.util.Collection<org.jboss.jca.validator.Failure> failures,
                                                   java.io.File reportDirectory,
                                                   org.jboss.jca.validator.FailureHelper... fhInput)

      print Failures into Log files.
      Parameters:
        `urlFileName` - urlFileName urlFileName filename Of deployed rar
        `validator` - validator validator validator instance used to run validation rules
        `failures` - failures failures the list of Failures to be printed
        `reportDirectory` - reportDirectory reportDirectory where to put various logs
        `fhInput` - fhInput fhInput optional parameter. Normally used only for test or in case of FailureHelper already present in context
      Returns:
        the error Text

    - #### hasFailuresLevel

          protected boolean hasFailuresLevel(java.util.Collection<org.jboss.jca.validator.Failure> failures,
                                             int severity)

      Cehck for failures at a certain level
      Parameters:
        `failures` - failures failures The failures
        `severity` - severity severity The level
      Returns:
        True if a failure is found with the specified severity; otherwise false

    - #### startContext

          protected void startContext(javax.resource.spi.ResourceAdapter resourceAdapter,
                                      java.lang.String bootstrapContextIdentifier,
                                      java.lang.String bootstrapContextName,
                                      org.jboss.jca.core.spi.security.Callback cb)
                               throws DeployException

      Start the resource adapter
      Parameters:
        `resourceAdapter` - The resource adapter
        `bootstrapContextIdentifier` - The bootstrap context identifier
        `bootstrapContextName` - The bootstrap context name; may be `null`
        `cb` - The callback
      Throws:
        `DeployException` - DeployException Thrown if the resource adapter cant be started

    - #### setCallbackSecurity

          protected void setCallbackSecurity(org.jboss.jca.core.api.workmanager.WorkManager workManager,
                                             org.jboss.jca.core.spi.security.Callback cb)

      Sets the call back security info in this rar work manager before starting the resource adapter.
      Parameters:
        `workManager` - the work manager that will be used by the resource adapter
        `cb` - the security callback

    - #### associateResourceAdapter

          protected void associateResourceAdapter(javax.resource.spi.ResourceAdapter resourceAdapter,
                                                  java.lang.Object object)
                                           throws DeployException

      Associate resource adapter with ojects if they implement ResourceAdapterAssociation
      Parameters:
        `resourceAdapter` - resourceAdapter resourceAdapter The resource adapter
        `object` - object object The of possible association object
      Throws:
        `DeployException` - DeployException Thrown if the resource adapter cant be started

    - #### findConnectionDefinitions

          protected java.util.Set<org.jboss.jca.common.api.metadata.resourceadapter.ConnectionDefinition> findConnectionDefinitions(java.lang.String clz,
                                                                                                                                    java.util.Set<java.lang.String> mcfs,
                                                                                                                                    java.util.List<org.jboss.jca.common.api.metadata.resourceadapter.ConnectionDefinition> defs,
                                                                                                                                    java.lang.ClassLoader cl)
                                                                                                                             throws DeployException

      Find the metadata for a managed connection factory
      Parameters:
        `clz` - The fully quilified class name for the managed connection factory
        `mcfs` - The managed connection facotries
        `defs` - The connection definitions
        `cl` - The class loader
      Returns:
        The metadata; `null` if none could be found
      Throws:
        `DeployException` - Thrown in case of configuration error

    - #### findAdminObjects

          protected java.util.Set<org.jboss.jca.common.api.metadata.resourceadapter.AdminObject> findAdminObjects(java.lang.String clz,
                                                                                                                  java.util.Set<java.lang.String> aos,
                                                                                                                  java.util.List<org.jboss.jca.common.api.metadata.resourceadapter.AdminObject> defs)
                                                                                                           throws DeployException

      Find the metadata for an admin object
      Parameters:
        `clz` - The fully quilified class name for the admin object
        `aos` - The admin object classes
        `defs` - The admin object definitions
      Returns:
        The metadata; `null` if none could be found
      Throws:
        `DeployException` - Thrown in case of configuration error

    - #### createPoolConfiguration

          protected org.jboss.jca.core.api.connectionmanager.pool.PoolConfiguration createPoolConfiguration(org.jboss.jca.common.api.metadata.common.Pool pp,
                                                                                                            org.jboss.jca.common.api.metadata.common.TimeOut tp,
                                                                                                            org.jboss.jca.common.api.metadata.common.Validation vp)

      Create an instance of the pool configuration based on the input
      Parameters:
        `pp` - The pool parameters
        `tp` - The timeout parameters
        `vp` - The validation parameters
      Returns:
        The configuration

    - #### start

          public void start()

      Start

    - #### initActivationSpec

          protected java.util.Set<org.jboss.jca.validator.Failure> initActivationSpec(java.lang.ClassLoader cl,
                                                                                      org.jboss.jca.common.api.metadata.spec.Connector cmd,
                                                                                      javax.resource.spi.ResourceAdapter resourceAdapter,
                                                                                      java.util.List<org.jboss.jca.validator.Validate> archiveValidationObjects,
                                                                                      java.util.List<java.lang.Object> beanValidationObjects,
                                                                                      java.util.Set<org.jboss.jca.validator.Failure> failures,
                                                                                      java.net.URL url,
                                                                                      boolean activateDeployment)
                                                                               throws DeployException

      init the acrtivation spec
      Parameters:
        `cl` - cl
        `cmd` - cmd
        `resourceAdapter` - resourceAdapter
        `archiveValidationObjects` - archiveValidationObjects
        `beanValidationObjects` - beanValidationObjects
        `failures` - falures to be updated during implemented operations
        `url` - url
        `activateDeployment` - activateDeployment
      Returns:
        failures updated after implemented operations
      Throws:
        `DeployException` - DeployException in case of error

    - #### initAdminObject

          protected java.util.Set<org.jboss.jca.validator.Failure> initAdminObject(org.jboss.jca.common.api.metadata.spec.Connector cmd,
                                                                                   java.lang.ClassLoader cl,
                                                                                   java.util.List<org.jboss.jca.validator.Validate> archiveValidationObjects,
                                                                                   java.util.List<java.lang.Object> beanValidationObjects,
                                                                                   java.util.Set<org.jboss.jca.validator.Failure> failures,
                                                                                   java.net.URL url,
                                                                                   java.lang.String deploymentName,
                                                                                   boolean activateDeployment,
                                                                                   javax.resource.spi.ResourceAdapter resourceAdapter,
                                                                                   java.util.List<org.jboss.jca.common.api.metadata.resourceadapter.AdminObject> aosAct,
                                                                                   java.util.List<java.lang.Object> aos,
                                                                                   java.util.List<java.lang.String> aoJndiNames,
                                                                                   org.jboss.jca.core.api.management.Connector mgtConnector)
                                                                            throws DeployException

      init an Admin Object
      Parameters:
        `cmd` - cmd
        `cl` - cl
        `archiveValidationObjects` - archiveValidationObjects
        `beanValidationObjects` - beanValidationObjects
        `failures` - falures to be updated during implemented operations
        `url` - url
        `deploymentName` - The deployment name
        `activateDeployment` - activateDeployment
        `resourceAdapter` - The resource adapter instance
        `aosAct` - Admin object definitions from activation
        `aos` - The resulting array of admin objects
        `aoJndiNames` - The resulting array of JNDI names
        `mgtConnector` - The management view of the connector
      Returns:
        failures updated after implemented operations
      Throws:
        `DeployException` - DeployException in case of errors

    - #### createObjectsAndInjectValue

          protected CommonDeployment createObjectsAndInjectValue(java.net.URL url,
                                                                 java.lang.String deploymentName,
                                                                 java.io.File root,
                                                                 java.lang.ClassLoader cl,
                                                                 org.jboss.jca.common.api.metadata.spec.Connector cmd,
                                                                 org.jboss.jca.common.api.metadata.resourceadapter.Activation activation)
                                                          throws DeployException,
                                                                 javax.resource.ResourceException,
                                                                 org.jboss.jca.validator.ValidatorException,
                                                                 org.jboss.jca.core.spi.mdr.AlreadyExistsException,
                                                                 java.lang.ClassNotFoundException,
                                                                 java.lang.Throwable

      create objects and inject value for this deployment. it is a general method returning a `CommonDeployment` to be used to exchange objects needed to real injection in the container
      Parameters:
        `url` - url
        `deploymentName` - deploymentName
        `root` - root
        `cl` - cl
        `cmd` - connector md
        `activation` - activation md
      Returns:
        return the exchange POJO with value useful for injection in the container (fungal or AS)
      Throws:
        `DeployException` - DeployException
        `javax.resource.ResourceException` - ResourceException
        `org.jboss.jca.validator.ValidatorException` - ValidatorException
        `org.jboss.jca.core.spi.mdr.AlreadyExistsException` - AlreadyExistsException
        `java.lang.ClassNotFoundException` - ClassNotFoundException
        `java.lang.Throwable` - Throwable

    - #### buildJndiName

          protected java.lang.String buildJndiName(java.lang.String jndiName,
                                                   java.lang.Boolean javaContext)

      Build the jndi name
      Parameters:
        `jndiName` - The jndi name
        `javaContext` - The java context
      Returns:
        The value

    - #### requireExplicitJndiBindings

          protected boolean requireExplicitJndiBindings()

      Require explicit JNDI bindings
      Returns:
        True if explicit JNDI bindings are required; otherwise false

    - #### getSubjectFactory

          protected abstract org.jboss.jca.core.spi.security.SubjectFactory getSubjectFactory(org.jboss.jca.common.api.metadata.common.SecurityMetadata securityMetadata,
                                                                                              java.lang.String jndiName)
                                                                                       throws DeployException

      Get a subject factory
      Parameters:
        `securityMetadata` - The security metadata: contains the security domain and any other necessary information for returning the subject factory
        `jndiName` - optionally used for authentication context matching
      Returns:
        The subject factory; must return `null` if security domain isn't defined
      Throws:
        `DeployException` - Thrown if the security domain can't be resolved

    - #### createSubject

          protected javax.security.auth.Subject createSubject(org.jboss.jca.core.spi.security.SubjectFactory subjectFactory,
                                                              java.lang.String securityDomain,
                                                              javax.resource.spi.ManagedConnectionFactory mcf)

      Create a subject
      Parameters:
        `subjectFactory` - The subject factory
        `securityDomain` - The security domain
        `mcf` - The managed connection factory
      Returns:
        The subject; `null` in case of an error

    - #### getBeanValidation

          protected BeanValidation getBeanValidation()

      Get the bean validation module
      Returns:
        The module

    - #### getCachedConnectionManager

          protected abstract org.jboss.jca.core.api.connectionmanager.ccm.CachedConnectionManager getCachedConnectionManager()

      Get the cached connection manager
      Returns:
        The handle

    - #### createCallback

          protected org.jboss.jca.core.spi.security.Callback createCallback(org.jboss.jca.common.api.metadata.resourceadapter.WorkManagerSecurity ws)

      Get a callback implementation
      Parameters:
        `ws` - The WorkManager security settings
      Returns:
        The value

    - #### applyCapacity

          protected void applyCapacity(org.jboss.jca.common.api.metadata.resourceadapter.ConnectionDefinition connectionDefinition,
                                       org.jboss.jca.core.connectionmanager.pool.api.Pool pool,
                                       boolean isCRI)

      Apply capacity
      Parameters:
        `connectionDefinition` - The connection definition
        `pool` - The pool
        `isCRI` - Is the pool going to be CRI based

    - #### scanArchive

          protected boolean scanArchive(org.jboss.jca.common.api.metadata.spec.Connector cmd)

      Should the archive be scanned for annotations
      Parameters:
        `cmd` - The metadata
      Returns:
        True if scan is needed; otherwise false

    - #### getReportDirectory

          protected abstract java.io.File getReportDirectory()

      get The directory where write error reports
      Returns:
        the directory as `File`

    - #### registerResourceAdapterToMDR

          protected abstract void registerResourceAdapterToMDR(java.net.URL url,
                                                               java.io.File root,
                                                               org.jboss.jca.common.api.metadata.spec.Connector cmd,
                                                               org.jboss.jca.common.api.metadata.resourceadapter.Activation activation)
                                                        throws org.jboss.jca.core.spi.mdr.AlreadyExistsException

      Register the ResourceAdapter to the MDR. Implementer should provide the implementation to get MDR and do the registration
      Parameters:
        `url` - url
        `root` - root
        `cmd` - cmd
        `activation` - activation
      Throws:
        `org.jboss.jca.core.spi.mdr.AlreadyExistsException` - AlreadyExistsException

    - #### registerResourceAdapterToResourceAdapterRepository

          protected abstract java.lang.String registerResourceAdapterToResourceAdapterRepository(javax.resource.spi.ResourceAdapter instance)

      Register the ResourceAdapter to the ResourceAdapterRepository. Implementer should provide the implementation to get repository and do the registration
      Parameters:
        `instance` - the instance
      Returns:
        The key

    - #### setRecoveryForResourceAdapterInResourceAdapterRepository

          protected abstract void setRecoveryForResourceAdapterInResourceAdapterRepository(java.lang.String key,
                                                                                           boolean isXA)

      Set recovery mode for a resource adapter in the ResourceAdapterRepository
      Parameters:
        `key` - The key for the resource adapter
        `isXA` - Is the resource adapter XA capable

    - #### getTransactionManager

          protected abstract javax.transaction.TransactionManager getTransactionManager()

      Get the transaction Manager. Implementers have to provide right implementation to find and get it
      Returns:
        The value

    - #### getTransactionIntegration

          protected abstract org.jboss.jca.core.spi.transaction.TransactionIntegration getTransactionIntegration()

      Get the transaction integration. Implementers have to provide right implementation to find and get it
      Returns:
        The value

    - #### getLogPrintWriter

          protected abstract java.io.PrintWriter getLogPrintWriter()

      get a PrintWriter where logger will put its output
      Returns:
        the printWriter for Logger

    - #### bindConnectionFactory

          protected abstract java.lang.String[] bindConnectionFactory(java.net.URL url,
                                                                      java.lang.String deploymentName,
                                                                      java.lang.Object cf)
                                                               throws java.lang.Throwable

      Bind connection factory into JNDI
      Parameters:
        `url` - The deployment URL
        `deploymentName` - The deployment name
        `cf` - The connection factory
      Returns:
        The JNDI names bound
      Throws:
        `java.lang.Throwable` - Thrown if an error occurs

    - #### bindConnectionFactory

          protected abstract java.lang.String[] bindConnectionFactory(java.net.URL url,
                                                                      java.lang.String deploymentName,
                                                                      java.lang.Object cf,
                                                                      java.lang.String jndiName)
                                                               throws java.lang.Throwable

      Bind connection factory into JNDI
      Parameters:
        `url` - The deployment URL
        `deploymentName` - The deployment name
        `cf` - The connection factory
        `jndiName` - The JNDI name
      Returns:
        The JNDI names bound
      Throws:
        `java.lang.Throwable` - Thrown if an error occurs

    - #### bindAdminObject

          protected abstract java.lang.String[] bindAdminObject(java.net.URL url,
                                                                java.lang.String deploymentName,
                                                                java.lang.Object ao)
                                                         throws java.lang.Throwable

      Bind admin object into JNDI
      Parameters:
        `url` - The deployment URL
        `deploymentName` - The deployment name
        `ao` - The admin object
      Returns:
        The JNDI names bound
      Throws:
        `java.lang.Throwable` - Thrown if an error occurs

    - #### bindAdminObject

          protected abstract java.lang.String[] bindAdminObject(java.net.URL url,
                                                                java.lang.String deploymentName,
                                                                java.lang.Object ao,
                                                                java.lang.String jndiName)
                                                         throws java.lang.Throwable

      Bind admin object into JNDI
      Parameters:
        `url` - The deployment URL
        `deploymentName` - The deployment name
        `ao` - The admin object
        `jndiName` - The JNDI name
      Returns:
        The JNDI names bound
      Throws:
        `java.lang.Throwable` - Thrown if an error occurs

    - #### checkConfigurationIsValid

          protected abstract boolean checkConfigurationIsValid()

      check if the configuration for this deployer has been set to a valid value
      Returns:
        false if configuration is not valid

    - #### checkActivation

          protected abstract boolean checkActivation(org.jboss.jca.common.api.metadata.spec.Connector cmd,
                                                     org.jboss.jca.common.api.metadata.resourceadapter.Activation activation)

      Check if the resource adapter should be activated based on the ironjacamar.xml input
      Parameters:
        `cmd` - cmd cmd The connector metadata
        `activation` - The activation metadata
      Returns:
        True if the deployment should be activated; otherwise false

    - #### initAndInject

          protected abstract java.lang.Object initAndInject(java.lang.String value,
                                                            java.util.List<? extends org.jboss.jca.common.api.metadata.spec.ConfigProperty> cpm,
                                                            java.lang.ClassLoader cl)
                                                     throws DeployException

      Initialize and inject configuration properties into container
      Parameters:
        `value` - value
        `cpm` - confi properties
        `cl` - The class loader
      Returns:
        The object
      Throws:
        `DeployException` - DeployException Thrown if the object cant be initialized

    - #### getLogger

          protected abstract DeployersLogger getLogger()

      Get the logger
      Returns:
        The value

Copyright © 2014 IronJacamar (http://www.ironjacamar.org)